--[[
   	Veresa's Arena Helper

      Version: b 1.1
      Build: 2007.02.19
      Last Change: 2007.02.21

      by

        		Veresa

		"A programmer is just a tool which converts coffeine into code."
]]--

--------------------------------------------------------------------------------------------------
-- Global variables:

-- data 
VAH_DATA = { };

-------------------------------------------------------------------------------------------------- OnLoad
function VAH_OnLoad()
  	this:RegisterEvent("VARIABLES_LOADED");
  	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
  	
   VAH_DATA = { };
   VAH_DATA.Enabled = false;
   
   VAH_DATA.Broadcast = { };
   VAH_DATA.Broadcast.Enabled = true;
   VAH_DATA.Broadcast.Channel = "battleground";
   VAH_DATA.Broadcast.Time = 100;
   
   VAH_DATA.UpdateInterval = 0.33;
   VAH_DATA.UpdateTime = 0;
   VAH_DATA.TimeLeft = 0;
end

-------------------------------------------------------------------------------------------------- OnEvent
function VAH_OnEvent(event)
   if( event == "VARIABLES_LOADED" ) then
      if( VAH_SAVE == nil ) then
         VAH_SAVE = VAH_DATA;
      else
         VAH_DATA = VAH_SAVE;
      end
      return;
   end
   
   for key, timemsg in pairs(VAH_STARTTIME_MSG) do
      if( arg1 == timemsg.Text or string.find(arg1, timemsg.Text) ) then
         VAH_DATA.Enabled = true;
         VAH_DATA.TimeLeft = timemsg.Left;
         -- :DEBUG:
         -- ChatMessageVAH("message triggers (".. key ..")");
         break;
      end
   end
end

-------------------------------------------------------------------------------------------------- OnEvent
function VAH_OnUpdate(elapsed)
   if( VAH_DATA.Enabled == true ) then
   
      VAH_DATA.TimeLeft = VAH_DATA.TimeLeft - elapsed;
      VAH_DATA.UpdateTime = VAH_DATA.UpdateTime + elapsed;

      if( VAH_DATA.TimeLeft <= 0 ) then -- check if fight started
         VAH_End();
         
      elseif( VAH_DATA.UpdateTime >= VAH_DATA.UpdateInterval ) then -- upadte
         VAH_DATA.UpdateTime = VAH_DATA.UpdateTime - VAH_DATA.UpdateInterval;
         
         if( VAH_DATA.Broadcast.Time > VAH_DATA.TimeLeft ) then
            VAH_DATA.Broadcast.Time = tonumber(format("%d",VAH_DATA.TimeLeft));
            if( mod( VAH_DATA.Broadcast.Time, 10 ) == 0 or VAH_DATA.Broadcast.Time == 15 or VAH_DATA.Broadcast.Time < 6 ) then
               if( VAH_DATA.Broadcast.Time > 0 ) then
                  BroadcastMessageVAH(VAH_DATA.Broadcast.Time);
               end
            end
         end
      end                    
   end
end

-------------------------------------------------------------------------------------------------- End
function VAH_End()

   VAH_DATA.TimeLeft = -1;
   VAH_DATA.Enabled = false;
  	VAH_DATA.UpdateTime = 0;
  	VAH_DATA.Broadcast.Time = 100;
         
   if( VAH_START_BROADCAST_MSG ~= nil and #VAH_START_BROADCAST_MSG > 0 ) then
      BroadcastMessageVAH( VAH_START_BROADCAST_MSG[ random(#VAH_START_BROADCAST_MSG) ] );
   end
end

--------------------------------------------------------------------------------------------------
function ChatMessageVAH(message)
   DEFAULT_CHAT_FRAME:AddMessage(message); 
end

--------------------------------------------------------------------------------------------------
function BroadcastMessageVAH(message)
   if( VAH_DATA.Broadcast.Enabled == true ) then
      SendChatMessage(message, string.upper(VAH_DATA.Broadcast.Channel), nil);
   else
      ChatMessageVAH(message);
   end
end

--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------



--------------------------------------------------------------------------------------------------
function VAH_CalcArenaPoints(team, rating)
   local points = 0;
	if( rating > 1500 ) then
      points = 2894 / ( 1 + 259 * math.pow(2.718281828459, (-0.0025*rating)) );
	else
      points = (0.206 * rating) + 99;
	end
	points = points + 0.5;
   if( team == VAH_NAME_2VS2 ) then
      points = points * 0.6;
   elseif( team == VAH_NAME_3VS3 ) then
      points = points * 0.8;
   end
   
   return (format("%d", points));
end

--------------------------------------------------------------------------------------------------
function VAH_ToggleTimeLeftBroadcast()
   if( VAH_DATA.Broadcast.Enabled == true ) then
      VAH_DATA.Broadcast.Enabled = false;   
      ChatMessageVAH("ArenaHelper: Broadcast disabled");
   else
      VAH_DATA.Broadcast.Enabled = true;
      ChatMessageVAH("ArenaHelper: Broadcast enabled");
   end
end


--------------------------------------------------------------------------------------------------
function VAH_ShowRatingTooltip()
   GameTooltip:SetOwner(PVPTeamDetails, "ANCHOR_NONE");
	GameTooltip:SetPoint("TOPLEFT", PVPTeamDetails, "TOPRIGHT", 5, 0);
	
	-- get the team data for calculating the arena points
	-- i dont know if there are functions for that... so i read the dialog data
   if( PVPTeamDetailsRating:GetText() == nil
       or string.len(PVPTeamDetailsRating:GetText()) <= 0
       or PVPTeamDetailsSize:GetText() == nil
       or string.len(PVPTeamDetailsSize:GetText()) <= 0 ) then
      return;
   end

	local rating = tonumber(PVPTeamDetailsRating:GetText());	
	GameTooltip:SetText("Points: ".. VAH_CalcArenaPoints(PVPTeamDetailsSize:GetText(), rating));
end

--------------------------------------------------------------------------------------------------
function VAH_HideRatingTooltip()
   GameTooltip:FadeOut();
end




--------------------------------------------------------------------------------------------------
function VAH_ShowInspecRatingTooltip(nr)
   --ChatMessageVAH("show inspec: ".. nr);
   GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint("BOTTOMRIGHT", "InspectPVPTeam"..nr, "TOPRIGHT", -20, 5);

	-- get the team data for calculating the arena points
	-- i dont know if there are functions for that... so i read the dialog data
   if( getglobal("InspectPVPTeam"..nr.."DataRating") == nil
       or string.len(getglobal("InspectPVPTeam"..nr.."DataRating"):GetText()) <= 0 ) then
       -- ChatMessageVAH("nil");
      return;
   end
	local rating = tonumber(getglobal("InspectPVPTeam"..nr.."DataRating"):GetText());
	
   -- :DEBUG:
   -- ChatMessageVAH("rating: ".. rating);

	GameTooltip:SetText("Arena-Points:"..
      "\n- ".. VAH_NAME_2VS2 ..": ".. VAH_CalcArenaPoints(VAH_NAME_2VS2, rating) ..
      "\n- ".. VAH_NAME_3VS3 ..": ".. VAH_CalcArenaPoints(VAH_NAME_3VS3, rating) ..
      "\n- ".. VAH_NAME_5VS5 ..": ".. VAH_CalcArenaPoints(VAH_NAME_5VS5, rating));
end

